<?
// integration class for Simple Machines Forum (www.simplemachines.org)
// written by Manuel Aristarn <masterson@diosmilanesa.com.ar>


$smf_root_path = realpath(dirname(__FILE__) . '/../../../') . '/';

if (!defined("SMF")) define("SMF", "1");

include($smf_root_path . 'Settings.php');
include($smf_root_path . 'Sources/Load.php');
include($smf_root_path . 'Sources/Subs-Auth.php');

class SMFCMS {

  var $userid;
  var $loginStmt;
  var $getUserStmt;
  var $getUsersStmt;

  function SMFCMS() {

    $this->loginStmt = new Statement("SELECT ID_MEMBER as id, memberName AS login, passwd, is_activated from {$GLOBALS['db_prefix']}members WHERE memberName=? AND passwd=?");
    $this->getUserStmt = new Statement("SELECT ID_MEMBER AS id, memberName AS login, ID_GROUP as status FROM {$GLOBALS['db_prefix']}members WHERE ID_MEMBER=?");
    $this->getUsersStmt = new Statement("SELECT ID_MEMBER as id, memberName as login FROM {$GLOBALS['db_prefix']}members");

    $this->userid = NULL;

    if (isset($_COOKIE[$GLOBALS['cookiename']])) {
      $cookieData = unserialize((get_magic_quotes_gpc() ? stripslashes($_COOKIE[$GLOBALS['cookiename']]) : $_COOKIE[$GLOBALS['cookiename']])) ;
      $this->userid = $cookieData[0];
     }
 
  }


  function isLoggedIn() {
    return $this->userid;
  }

  function getRoles($status) {
    $rv = NULL;

    if ($status == 1 || $status == 2)
      $rv = ROLE_ADMIN;
    else
      $rv = ROLE_USER;

    return $rv;
  }

  function getUserProfile($userid) {

    if ($userid == SPY_USERID) $rv = NULL;

    elseif ($user = $this->getUser($userid)) {
      $rv  = $GLOBALS['boardurl'] . "/index.php?action=profile;u=".$userid;
    }

    return $rv;
  }


  function getUser($userid) {
    
    
    $rv = NULL;
    if(($rs = $this->getUserStmt->process($userid)) && ($rec = $rs->next())) {
      $rec['roles'] = $this->getRoles($rec['status']);
      $rv = $rec;
    }

    return $rv;
  }

  function login($login, $password) {

    $md5_password = md5_hmac($password, strtolower($login));
    
    $rs = $this->loginStmt->process($login,$md5_password);
    
    $rec = $rs->next();
       
    if ($rec) {

      // is the user activated?
      if (empty($rec['is_activated'])) return NULL;

      $this->userid = $rec['id'];
                  
      setLoginCookie(60 * $GLOBALS['modSettings']['cookieTime'], $rec['id'], $md5_password);
      
      return $rec['id'];
     
    }
  }

  function userInRole($userid, $role) {

    $rv = NULL;

    if($user = $this->getUser($userid)) {
      $rv = (($user['roles'] & $role) != 0);
    }

    return $rv;

  }

  function logout() {

  }

  function getUsers() {
   return $this->getUsersStmt->process();
  }

}


$GLOBALS['fc_config']['db'] = array(
                 'host' => $db_server,
                 'user' => $db_user,
                 'pass' => $db_passwd,
                 'base' => $db_name,
                 'pref' => $db_prefix . "fc_",
                 );

$GLOBALS['fc_config']['cms'] = new SMFCMS();



foreach($GLOBALS['fc_config']['languages'] as $k => $v) {
  $GLOBALS['fc_config']['languages'][$k]['dialog']['login']['moderator'] = '';
}

?>